//+------------------------------------------------------------------+
//|                                        MACD - Zones.mq4 |
/*"Denis Orlov"
"http://denis-or-love.narod.ru"
*/
//+------------------------------------------------------------------+
#property copyright "Denis Orlov"
#property link      "http://denis-or-love.narod.ru"

#property indicator_chart_window

#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_color2 Navy
#property indicator_color3 Orange
#property indicator_color4 Crimson
#property indicator_color5 Blue
#property indicator_color6 Navy
#property indicator_color7 Orange
#property indicator_color8 Crimson

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

//----
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
extern bool Candles=True;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,0,1);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,1);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,1);
   SetIndexBuffer(3,ExtMapBuffer4);
   
   SetIndexStyle(4,DRAW_HISTOGRAM,0,3);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_HISTOGRAM,0,3);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexStyle(6,DRAW_HISTOGRAM,0,3);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexStyle(7,DRAW_HISTOGRAM,0,3);
   SetIndexBuffer(7,ExtMapBuffer8);
//----
   string short_name="MACD - Zones";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"MACD UP & >0");
   SetIndexLabel(1,"MACD UP & <0");
   SetIndexLabel(2,"MACD Down & >0");
   SetIndexLabel(3,"MACD Down & <0");
   
   SetIndexDrawBegin(0,10);
   SetIndexDrawBegin(1,10);
   SetIndexDrawBegin(2,10);
   SetIndexDrawBegin(3,10); 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int  i,counted_bars=IndicatorCounted();    
//----
   if(Bars<=10) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=10;i++) 
      {
      ExtMapBuffer1[Bars-i]=0.0;
      ExtMapBuffer2[Bars-i]=0.0;
      ExtMapBuffer3[Bars-i]=0.0;
      ExtMapBuffer4[Bars-i]=0.0;
      
      }
//----
   if ( counted_bars > 0 )  int limit=Bars-counted_bars;
   if ( counted_bars ==0 )  limit=Bars-10-1; 
        
   for(i=limit;i>=0;i--) 
   {	 
   double v0=iMACD(NULL,0,FastEMA,SlowEMA, SignalSMA, 
                  PRICE_CLOSE, MODE_MAIN, i),
                  
           v1=iMACD(NULL,0,FastEMA,SlowEMA, SignalSMA, 
                  PRICE_CLOSE, MODE_MAIN, i+1);       
   

   ExtMapBuffer1[i] =EMPTY;
   ExtMapBuffer2[i] =EMPTY;
   ExtMapBuffer3[i] =EMPTY;
   ExtMapBuffer4[i] =EMPTY;
   ExtMapBuffer5[i] =EMPTY;
   ExtMapBuffer6[i] =EMPTY;
   ExtMapBuffer7[i] =EMPTY;
   ExtMapBuffer8[i] =EMPTY;
   
   if (v0>v1)
      {
         if(v0>0)
            {
               ExtMapBuffer1[i] = High[i];ExtMapBuffer2[i] = Low[i] ;
               if(Candles)
                  {
                     ExtMapBuffer5[i] = HighBody(i);ExtMapBuffer6[i] = LowBody(i) ;
                  }
            }
            else
            {
               ExtMapBuffer2[i] = High[i];ExtMapBuffer1[i] = Low[i] ;
               if(Candles)
                  {
                     ExtMapBuffer6[i] = HighBody(i); ExtMapBuffer5[i] = LowBody(i) ;
                  }
            }
      }
      else
     if (v0<=v1)
      {
         if(v0>0)
            {
               ExtMapBuffer3[i] = High[i];ExtMapBuffer4[i] = Low[i] ;
               if(Candles)
                  {
                     ExtMapBuffer7[i] = HighBody(i);ExtMapBuffer8[i] = LowBody(i) ;
                  }
               
            }
            else
            {
               ExtMapBuffer4[i] = High[i];ExtMapBuffer3[i] = Low[i] ;
               if(Candles)
                  {
                     ExtMapBuffer8[i] = HighBody(i); ExtMapBuffer7[i] = LowBody(i) ;
                  }
            }
      } 
   
   
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+
double HighBody(int BarN)
   {
   if (Open[BarN]<Close[BarN]) return(Close[BarN]);
   else return(Open[BarN]);
    
   }
double LowBody(int BarN)
   {
   if (Open[BarN]<Close[BarN]) return(Open[BarN]);
   else return(Close[BarN]);
   }